/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 
 */
@ApiModel(description = "")

public class ObtainTokenRequest {
  @JsonProperty("client_id")
  private String clientId = null;

  @JsonProperty("client_secret")
  private String clientSecret = null;

  @JsonProperty("code")
  private String code = null;

  @JsonProperty("redirect_uri")
  private String redirectUri = null;

  public ObtainTokenRequest clientId(String clientId) {
    this.clientId = clientId;
    return this;
  }

   /**
   * Your application's ID, available from the [application dashboard](https://connect.squareup.com/apps).
   * @return clientId
  **/
  @ApiModelProperty(value = "Your application's ID, available from the [application dashboard](https://connect.squareup.com/apps).")
  public String getClientId() {
    return clientId;
  }

  public void setClientId(String clientId) {
    this.clientId = clientId;
  }

  public ObtainTokenRequest clientSecret(String clientSecret) {
    this.clientSecret = clientSecret;
    return this;
  }

   /**
   * Your application's secret, available from the [application dashboard](https://connect.squareup.com/apps).
   * @return clientSecret
  **/
  @ApiModelProperty(value = "Your application's secret, available from the [application dashboard](https://connect.squareup.com/apps).")
  public String getClientSecret() {
    return clientSecret;
  }

  public void setClientSecret(String clientSecret) {
    this.clientSecret = clientSecret;
  }

  public ObtainTokenRequest code(String code) {
    this.code = code;
    return this;
  }

   /**
   * The authorization code to exchange.
   * @return code
  **/
  @ApiModelProperty(value = "The authorization code to exchange.")
  public String getCode() {
    return code;
  }

  public void setCode(String code) {
    this.code = code;
  }

  public ObtainTokenRequest redirectUri(String redirectUri) {
    this.redirectUri = redirectUri;
    return this;
  }

   /**
   * The redirect URL assigned in the [application dashboard](https://connect.squareup.com/apps).
   * @return redirectUri
  **/
  @ApiModelProperty(value = "The redirect URL assigned in the [application dashboard](https://connect.squareup.com/apps).")
  public String getRedirectUri() {
    return redirectUri;
  }

  public void setRedirectUri(String redirectUri) {
    this.redirectUri = redirectUri;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ObtainTokenRequest obtainTokenRequest = (ObtainTokenRequest) o;
    return Objects.equals(this.clientId, obtainTokenRequest.clientId) &&
        Objects.equals(this.clientSecret, obtainTokenRequest.clientSecret) &&
        Objects.equals(this.code, obtainTokenRequest.code) &&
        Objects.equals(this.redirectUri, obtainTokenRequest.redirectUri);
  }

  @Override
  public int hashCode() {
    return Objects.hash(clientId, clientSecret, code, redirectUri);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ObtainTokenRequest {\n");
    
    sb.append("    clientId: ").append(toIndentedString(clientId)).append("\n");
    sb.append("    clientSecret: ").append(toIndentedString(clientSecret)).append("\n");
    sb.append("    code: ").append(toIndentedString(code)).append("\n");
    sb.append("    redirectUri: ").append(toIndentedString(redirectUri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

