/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.OrderFulfillmentRecipient;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Contains details necessary to fulfill a pickup order.
 */
@ApiModel(description = "Contains details necessary to fulfill a pickup order.")

public class OrderFulfillmentPickupDetails {
  @JsonProperty("recipient")
  private OrderFulfillmentRecipient recipient = null;

  @JsonProperty("expires_at")
  private String expiresAt = null;

  @JsonProperty("auto_complete_duration")
  private String autoCompleteDuration = null;

  /**
   * The schedule type of the pickup fulfillment. Defaults to `SCHEDULED`.
   */
  public enum ScheduleTypeEnum {
    SCHEDULED("SCHEDULED"),
    
    ASAP("ASAP");

    private String value;

    ScheduleTypeEnum(String value) {
      this.value = value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static ScheduleTypeEnum fromValue(String text) {
      for (ScheduleTypeEnum b : ScheduleTypeEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }
  }

  @JsonProperty("schedule_type")
  private ScheduleTypeEnum scheduleType = null;

  @JsonProperty("pickup_at")
  private String pickupAt = null;

  @JsonProperty("pickup_window_duration")
  private String pickupWindowDuration = null;

  @JsonProperty("prep_time_duration")
  private String prepTimeDuration = null;

  @JsonProperty("note")
  private String note = null;

  @JsonProperty("placed_at")
  private String placedAt = null;

  @JsonProperty("accepted_at")
  private String acceptedAt = null;

  @JsonProperty("rejected_at")
  private String rejectedAt = null;

  @JsonProperty("ready_at")
  private String readyAt = null;

  @JsonProperty("expired_at")
  private String expiredAt = null;

  @JsonProperty("picked_up_at")
  private String pickedUpAt = null;

  @JsonProperty("canceled_at")
  private String canceledAt = null;

  @JsonProperty("cancel_reason")
  private String cancelReason = null;

  public OrderFulfillmentPickupDetails recipient(OrderFulfillmentRecipient recipient) {
    this.recipient = recipient;
    return this;
  }

   /**
   * The recipient of this pickup fulfillment.
   * @return recipient
  **/
  @ApiModelProperty(value = "The recipient of this pickup fulfillment.")
  public OrderFulfillmentRecipient getRecipient() {
    return recipient;
  }

  public void setRecipient(OrderFulfillmentRecipient recipient) {
    this.recipient = recipient;
  }

  public OrderFulfillmentPickupDetails expiresAt(String expiresAt) {
    this.expiresAt = expiresAt;
    return this;
  }

   /**
   * The expiry [timestamp](#workingwithdates) in RFC 3339 format, e.g., \"2016-09-04T23:59:33.123Z\". This timestamp indicates when the pickup fulfillment will expire if it is not accepted by the merchant. Expiration time can only be set up to 7 days in the future. If not set, this pickup fulfillment will be automatically accepted when placed.
   * @return expiresAt
  **/
  @ApiModelProperty(value = "The expiry [timestamp](#workingwithdates) in RFC 3339 format, e.g., \"2016-09-04T23:59:33.123Z\". This timestamp indicates when the pickup fulfillment will expire if it is not accepted by the merchant. Expiration time can only be set up to 7 days in the future. If not set, this pickup fulfillment will be automatically accepted when placed.")
  public String getExpiresAt() {
    return expiresAt;
  }

  public void setExpiresAt(String expiresAt) {
    this.expiresAt = expiresAt;
  }

  public OrderFulfillmentPickupDetails autoCompleteDuration(String autoCompleteDuration) {
    this.autoCompleteDuration = autoCompleteDuration;
    return this;
  }

   /**
   * The auto completion duration in RFC3339 duration format, e.g., \"P1W3D\". If set, an open and accepted pickup fulfillment will automatically move to the `COMPLETED` state after this period of time. If not set, this pickup fulfillment will remain accepted until it is canceled or completed.
   * @return autoCompleteDuration
  **/
  @ApiModelProperty(value = "The auto completion duration in RFC3339 duration format, e.g., \"P1W3D\". If set, an open and accepted pickup fulfillment will automatically move to the `COMPLETED` state after this period of time. If not set, this pickup fulfillment will remain accepted until it is canceled or completed.")
  public String getAutoCompleteDuration() {
    return autoCompleteDuration;
  }

  public void setAutoCompleteDuration(String autoCompleteDuration) {
    this.autoCompleteDuration = autoCompleteDuration;
  }

  public OrderFulfillmentPickupDetails scheduleType(ScheduleTypeEnum scheduleType) {
    this.scheduleType = scheduleType;
    return this;
  }

   /**
   * The schedule type of the pickup fulfillment. Defaults to `SCHEDULED`.
   * @return scheduleType
  **/
  @ApiModelProperty(value = "The schedule type of the pickup fulfillment. Defaults to `SCHEDULED`.")
  public ScheduleTypeEnum getScheduleType() {
    return scheduleType;
  }

  public void setScheduleType(ScheduleTypeEnum scheduleType) {
    this.scheduleType = scheduleType;
  }

  public OrderFulfillmentPickupDetails pickupAt(String pickupAt) {
    this.pickupAt = pickupAt;
    return this;
  }

   /**
   * The pickup [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\". For fulfillments with the schedule type `ASAP`, this is automatically set to the current time plus the expected duration to prepare the fulfillment. This represents the start of the pickup window.
   * @return pickupAt
  **/
  @ApiModelProperty(value = "The pickup [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\". For fulfillments with the schedule type `ASAP`, this is automatically set to the current time plus the expected duration to prepare the fulfillment. This represents the start of the pickup window.")
  public String getPickupAt() {
    return pickupAt;
  }

  public void setPickupAt(String pickupAt) {
    this.pickupAt = pickupAt;
  }

  public OrderFulfillmentPickupDetails pickupWindowDuration(String pickupWindowDuration) {
    this.pickupWindowDuration = pickupWindowDuration;
    return this;
  }

   /**
   * The pickup window duration in RFC3339 duration format, e.g., \"P1W3D\". This duration represents the window of time for which the order should be picked up after the `pickup_at` time. Can be used as an informational guideline for merchants.
   * @return pickupWindowDuration
  **/
  @ApiModelProperty(value = "The pickup window duration in RFC3339 duration format, e.g., \"P1W3D\". This duration represents the window of time for which the order should be picked up after the `pickup_at` time. Can be used as an informational guideline for merchants.")
  public String getPickupWindowDuration() {
    return pickupWindowDuration;
  }

  public void setPickupWindowDuration(String pickupWindowDuration) {
    this.pickupWindowDuration = pickupWindowDuration;
  }

  public OrderFulfillmentPickupDetails prepTimeDuration(String prepTimeDuration) {
    this.prepTimeDuration = prepTimeDuration;
    return this;
  }

   /**
   * The preparation time duration in RFC3339 duration format, e.g., \"P1W3D\". This duration indicates how long it takes the merchant to prepare this fulfillment.
   * @return prepTimeDuration
  **/
  @ApiModelProperty(value = "The preparation time duration in RFC3339 duration format, e.g., \"P1W3D\". This duration indicates how long it takes the merchant to prepare this fulfillment.")
  public String getPrepTimeDuration() {
    return prepTimeDuration;
  }

  public void setPrepTimeDuration(String prepTimeDuration) {
    this.prepTimeDuration = prepTimeDuration;
  }

  public OrderFulfillmentPickupDetails note(String note) {
    this.note = note;
    return this;
  }

   /**
   * A general note about the pickup fulfillment.  Notes are useful for providing additional instructions and are displayed in Square apps.
   * @return note
  **/
  @ApiModelProperty(value = "A general note about the pickup fulfillment.  Notes are useful for providing additional instructions and are displayed in Square apps.")
  public String getNote() {
    return note;
  }

  public void setNote(String note) {
    this.note = note;
  }

  public OrderFulfillmentPickupDetails placedAt(String placedAt) {
    this.placedAt = placedAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was placed.
   * @return placedAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was placed.")
  public String getPlacedAt() {
    return placedAt;
  }

  public void setPlacedAt(String placedAt) {
    this.placedAt = placedAt;
  }

  public OrderFulfillmentPickupDetails acceptedAt(String acceptedAt) {
    this.acceptedAt = acceptedAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was accepted by the merchant.
   * @return acceptedAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was accepted by the merchant.")
  public String getAcceptedAt() {
    return acceptedAt;
  }

  public void setAcceptedAt(String acceptedAt) {
    this.acceptedAt = acceptedAt;
  }

  public OrderFulfillmentPickupDetails rejectedAt(String rejectedAt) {
    this.rejectedAt = rejectedAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was rejected.
   * @return rejectedAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was rejected.")
  public String getRejectedAt() {
    return rejectedAt;
  }

  public void setRejectedAt(String rejectedAt) {
    this.rejectedAt = rejectedAt;
  }

  public OrderFulfillmentPickupDetails readyAt(String readyAt) {
    this.readyAt = readyAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the merchant set the fulfillment as ready for pickup.
   * @return readyAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the merchant set the fulfillment as ready for pickup.")
  public String getReadyAt() {
    return readyAt;
  }

  public void setReadyAt(String readyAt) {
    this.readyAt = readyAt;
  }

  public OrderFulfillmentPickupDetails expiredAt(String expiredAt) {
    this.expiredAt = expiredAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment expired.
   * @return expiredAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment expired.")
  public String getExpiredAt() {
    return expiredAt;
  }

  public void setExpiredAt(String expiredAt) {
    this.expiredAt = expiredAt;
  }

  public OrderFulfillmentPickupDetails pickedUpAt(String pickedUpAt) {
    this.pickedUpAt = pickedUpAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was picked up by the recipient.
   * @return pickedUpAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was picked up by the recipient.")
  public String getPickedUpAt() {
    return pickedUpAt;
  }

  public void setPickedUpAt(String pickedUpAt) {
    this.pickedUpAt = pickedUpAt;
  }

  public OrderFulfillmentPickupDetails canceledAt(String canceledAt) {
    this.canceledAt = canceledAt;
    return this;
  }

   /**
   * The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was canceled by the merchant or buyer.
   * @return canceledAt
  **/
  @ApiModelProperty(value = "The [timestamp](#workingwithdates) in RFC3339 timestamp format, e.g., \"2016-09-04T23:59:33.123Z\", indicating when the fulfillment was canceled by the merchant or buyer.")
  public String getCanceledAt() {
    return canceledAt;
  }

  public void setCanceledAt(String canceledAt) {
    this.canceledAt = canceledAt;
  }

  public OrderFulfillmentPickupDetails cancelReason(String cancelReason) {
    this.cancelReason = cancelReason;
    return this;
  }

   /**
   * A description of why the pickup was canceled. Max length is 100 characters.
   * @return cancelReason
  **/
  @ApiModelProperty(value = "A description of why the pickup was canceled. Max length is 100 characters.")
  public String getCancelReason() {
    return cancelReason;
  }

  public void setCancelReason(String cancelReason) {
    this.cancelReason = cancelReason;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderFulfillmentPickupDetails orderFulfillmentPickupDetails = (OrderFulfillmentPickupDetails) o;
    return Objects.equals(this.recipient, orderFulfillmentPickupDetails.recipient) &&
        Objects.equals(this.expiresAt, orderFulfillmentPickupDetails.expiresAt) &&
        Objects.equals(this.autoCompleteDuration, orderFulfillmentPickupDetails.autoCompleteDuration) &&
        Objects.equals(this.scheduleType, orderFulfillmentPickupDetails.scheduleType) &&
        Objects.equals(this.pickupAt, orderFulfillmentPickupDetails.pickupAt) &&
        Objects.equals(this.pickupWindowDuration, orderFulfillmentPickupDetails.pickupWindowDuration) &&
        Objects.equals(this.prepTimeDuration, orderFulfillmentPickupDetails.prepTimeDuration) &&
        Objects.equals(this.note, orderFulfillmentPickupDetails.note) &&
        Objects.equals(this.placedAt, orderFulfillmentPickupDetails.placedAt) &&
        Objects.equals(this.acceptedAt, orderFulfillmentPickupDetails.acceptedAt) &&
        Objects.equals(this.rejectedAt, orderFulfillmentPickupDetails.rejectedAt) &&
        Objects.equals(this.readyAt, orderFulfillmentPickupDetails.readyAt) &&
        Objects.equals(this.expiredAt, orderFulfillmentPickupDetails.expiredAt) &&
        Objects.equals(this.pickedUpAt, orderFulfillmentPickupDetails.pickedUpAt) &&
        Objects.equals(this.canceledAt, orderFulfillmentPickupDetails.canceledAt) &&
        Objects.equals(this.cancelReason, orderFulfillmentPickupDetails.cancelReason);
  }

  @Override
  public int hashCode() {
    return Objects.hash(recipient, expiresAt, autoCompleteDuration, scheduleType, pickupAt, pickupWindowDuration, prepTimeDuration, note, placedAt, acceptedAt, rejectedAt, readyAt, expiredAt, pickedUpAt, canceledAt, cancelReason);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderFulfillmentPickupDetails {\n");
    
    sb.append("    recipient: ").append(toIndentedString(recipient)).append("\n");
    sb.append("    expiresAt: ").append(toIndentedString(expiresAt)).append("\n");
    sb.append("    autoCompleteDuration: ").append(toIndentedString(autoCompleteDuration)).append("\n");
    sb.append("    scheduleType: ").append(toIndentedString(scheduleType)).append("\n");
    sb.append("    pickupAt: ").append(toIndentedString(pickupAt)).append("\n");
    sb.append("    pickupWindowDuration: ").append(toIndentedString(pickupWindowDuration)).append("\n");
    sb.append("    prepTimeDuration: ").append(toIndentedString(prepTimeDuration)).append("\n");
    sb.append("    note: ").append(toIndentedString(note)).append("\n");
    sb.append("    placedAt: ").append(toIndentedString(placedAt)).append("\n");
    sb.append("    acceptedAt: ").append(toIndentedString(acceptedAt)).append("\n");
    sb.append("    rejectedAt: ").append(toIndentedString(rejectedAt)).append("\n");
    sb.append("    readyAt: ").append(toIndentedString(readyAt)).append("\n");
    sb.append("    expiredAt: ").append(toIndentedString(expiredAt)).append("\n");
    sb.append("    pickedUpAt: ").append(toIndentedString(pickedUpAt)).append("\n");
    sb.append("    canceledAt: ").append(toIndentedString(canceledAt)).append("\n");
    sb.append("    cancelReason: ").append(toIndentedString(cancelReason)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

